package org.jboss.tools.sapphire;

import org.eclipse.sapphire.modeling.IModelElement;
import org.eclipse.sapphire.modeling.ListProperty;
import org.eclipse.sapphire.modeling.ModelElementList;
import org.eclipse.sapphire.modeling.ModelElementType;
import org.eclipse.sapphire.modeling.Value;
import org.eclipse.sapphire.modeling.ValueProperty;
import org.eclipse.sapphire.modeling.annotations.GenerateImpl;
import org.eclipse.sapphire.modeling.annotations.Label;
import org.eclipse.sapphire.modeling.annotations.NonNullValue;
import org.eclipse.sapphire.modeling.annotations.Type;
import org.eclipse.sapphire.modeling.xml.annotations.XmlBinding;
import org.eclipse.sapphire.modeling.xml.annotations.XmlListBinding;
import org.eclipse.sapphire.modeling.xml.annotations.XmlNamespace;

@XmlNamespace( uri = "urn:switchyard-component-bean:config:1.0", prefix = "bean" )
@GenerateImpl

public interface IComponent extends IModelElement {

    ModelElementType TYPE = new ModelElementType( IComponent.class );

    // *** Name ***
    
    @XmlBinding( path = "@name" )
    @Label( standard = "&Name" )
    @NonNullValue

    ValueProperty PROP_NAME = new ValueProperty( TYPE, "Name" );

    Value<String> getName();
    void setName( String value );

    // *** ImplementationBeans ***

    @Label( standard = "&Implementation Beans" )
    @Type( base = IImplementationBean.class )
    @XmlListBinding( mappings = @XmlListBinding.Mapping( element = "bean:implementation.bean", type = IImplementationBean.class ) )
    
    ListProperty PROP_IMPLEMENTATION_BEANS = new ListProperty( TYPE, "ImplementationBeans" );
    
    ModelElementList<IImplementationBean> getImplementationBeans();

    // *** Services ***

    @Type( base = IComponentService.class )
    @XmlListBinding( mappings = @XmlListBinding.Mapping( element = "service", type = IComponentService.class ) )
    
    ListProperty PROP_COMPONENT_SERVICES = new ListProperty( TYPE, "ComponentServices" );
    
    ModelElementList<IComponentService> getComponentServices();

    // *** Services ***

    @Type( base = IComponentServiceReference.class )
    @XmlListBinding( mappings = @XmlListBinding.Mapping( element = "reference", type = IComponentServiceReference.class ) )
    
    ListProperty PROP_COMPONENT_SERVICE_REFERENCES = new ListProperty( TYPE, "ComponentServiceReferences" );
    
    ModelElementList<IComponentServiceReference> getComponentServiceReferences();
}
