package org.jboss.tools.sapphire;

import org.eclipse.sapphire.modeling.IModelElement;
import org.eclipse.sapphire.modeling.ListProperty;
import org.eclipse.sapphire.modeling.ModelElementList;
import org.eclipse.sapphire.modeling.ModelElementType;
import org.eclipse.sapphire.modeling.Value;
import org.eclipse.sapphire.modeling.ValueProperty;
import org.eclipse.sapphire.modeling.annotations.GenerateImpl;
import org.eclipse.sapphire.modeling.annotations.Label;
import org.eclipse.sapphire.modeling.annotations.NonNullValue;
import org.eclipse.sapphire.modeling.annotations.Type;
import org.eclipse.sapphire.modeling.xml.annotations.XmlBinding;
import org.eclipse.sapphire.modeling.xml.annotations.XmlListBinding;

@GenerateImpl

public interface IComposite  extends IModelElement {

    ModelElementType TYPE = new ModelElementType( IComposite.class );

    // *** Name ***
    
    @XmlBinding( path = "@name" )
    @Label( standard = "&Name" )
    @NonNullValue

    ValueProperty PROP_NAME = new ValueProperty( TYPE, "Name" );

    Value<String> getName();
    void setName( String value );

    // *** targetNamespace ***
    
    @XmlBinding( path = "@targetNamespace" )
    @Label( standard = "&Target Namespace" )
    @NonNullValue

    ValueProperty PROP_TARGET_NAMESPACE = new ValueProperty( TYPE, "TargetNamespace" );

    Value<String> getTargetNamespace();
    void setTargetNamespace( String value );

    // *** Services ***

    @Type( base = IService.class )
    @XmlListBinding( mappings = @XmlListBinding.Mapping( element = "service", type = IService.class ) )
    
    ListProperty PROP_SERVICES = new ListProperty( TYPE, "Services" );
    
    ModelElementList<IService> getServices();

    // *** Components ***

    @Type( base = IComponent.class )
    @XmlListBinding( mappings = @XmlListBinding.Mapping( element = "component", type = IComponent.class ) )
    
    ListProperty PROP_COMPONENTS = new ListProperty( TYPE, "Components" );
    
    ModelElementList<IComponent> getComponents();

}
