package org.jboss.tools.sapphire;

import org.eclipse.sapphire.modeling.IModelElement;
import org.eclipse.sapphire.modeling.ModelElementType;
import org.eclipse.sapphire.modeling.Value;
import org.eclipse.sapphire.modeling.ValueProperty;
import org.eclipse.sapphire.modeling.annotations.GenerateImpl;
import org.eclipse.sapphire.modeling.annotations.Label;
import org.eclipse.sapphire.modeling.annotations.NonNullValue;
import org.eclipse.sapphire.modeling.xml.annotations.XmlBinding;

@GenerateImpl

public interface IInterfaceJava extends IModelElement {

    ModelElementType TYPE = new ModelElementType( IInterfaceJava.class );

    // *** java interface ***
    
    @XmlBinding( path = "interface.java/@interface" )
    @Label( standard = "&Interface" )
    @NonNullValue

    ValueProperty PROP_JAVA_INTERFACE = new ValueProperty( TYPE, "JavaInterface" );

    Value<String> getJavaInterface();
    void setJavaInterface ( String value );
}
