package org.jboss.tools.sapphire;

import org.eclipse.sapphire.modeling.IModelElement;
import org.eclipse.sapphire.modeling.ModelElementType;
import org.eclipse.sapphire.modeling.Value;
import org.eclipse.sapphire.modeling.ValueProperty;
import org.eclipse.sapphire.modeling.annotations.DefaultValue;
import org.eclipse.sapphire.modeling.annotations.GenerateImpl;
import org.eclipse.sapphire.modeling.annotations.Label;
import org.eclipse.sapphire.modeling.annotations.NonNullValue;
import org.eclipse.sapphire.modeling.annotations.Type;
import org.eclipse.sapphire.modeling.xml.annotations.XmlBinding;

@GenerateImpl

public interface ISOAPBinding  extends IModelElement{

    ModelElementType TYPE = new ModelElementType( ISOAPBinding.class );

    // *** serverPort ***
    @XmlBinding( path = "port" )
    @Label( standard = "&Port" )
    @NonNullValue

    ValueProperty PROP_PORT = new ValueProperty( TYPE, "Port" );

    Value<String> getPort();
    void setPort( String value );

    // *** WSDL ***
    
    @XmlBinding( path = "wsdl" )
    @Label( standard = "&WSDL" )
    @NonNullValue
    ValueProperty PROP_WSDL = new ValueProperty( TYPE, "WSDL" );

    Value<String> getWsdl();
    void setWsdl( String value );

    // *** secure ***
    
    @Type( base = Boolean.class)
    @XmlBinding( path = "port/@secure" )
    @Label( standard = "&Secure Port" )
    @DefaultValue(text = "false")

    ValueProperty PROP_SECURE = new ValueProperty( TYPE, "Secure" );

    Value<Boolean> getSecure();
    void setSecure ( String value );
    void setSecure ( Boolean value );

    // *** description ***
    
    @XmlBinding( path = "wsdl/@description" )
    @Label( standard = "&WSDL Description" )
    @DefaultValue(text = "false")

    ValueProperty PROP_WSDL_DESCRIPTION = new ValueProperty( TYPE, "WsdlDescription" );

    Value<String> getWsdlDescription();
    void setWsdlDescription ( String value );
}
